public interface FunctionIface: Object {
	/**
	 * Returns the function name
	 * @return	Instance owned function name
	 */
	public abstract unowned string get_name ();
	
	/**
	 * Prepares function for evaluating
	 * @param library	Library to link with 
	 * @return		FALSE on failure; TRUE otherwise
	*/
	public abstract bool link_with (Library library);
	
	/**
	 * Evaluates the function. You MUST call link_with
	 * before this method and after each library updates.
	 * @param arg	Argument
	 * @return	Function value from @arg
	*/
	public abstract double evaluate (double arg);
	
	/**
	 * Construct derivative
	 * @return	Derivative object
	*/
	public abstract FunctionIface derivate ();
}

